#include "..\common\common.h"

wmain(int argc, WCHAR *argv[]) {

	HANDLE hFile;
	WCHAR wstrFileName[4+BUFSIZE] = L"\\\\?\\";

	/* Argument Check */
	if (argc != 2) {
		fprintf(stderr, "Usage: %S FileName[:StreamName]\n", argv[0]);
		fprintf(stderr, "       FileName can consist of the file name (up to 255 Unicode chars) \n");
		fprintf(stderr, "       and StreamName (up to 255 Unicode chars) \n");
		ExitProcess(1);
	}

	/* generate full path name */
	{
		WCHAR *lpwstrFileName;
		if (GetFullPathNameW(argv[1], BUFSIZE, wstrFileName+4, &lpwstrFileName) == 0) {
			PrintErrorMessage(__FILE__, "GetFullPathNameW", __LINE__);
			ExitProcess(1);
		}
	}

	hFile = CreateFileW(wstrFileName,
        GENERIC_READ|GENERIC_WRITE,  // open for reading 
        0,
        NULL,                      // no security 
        OPEN_ALWAYS,               // create if the file does not exist
        FILE_ATTRIBUTE_NORMAL,     // normal file 
        NULL);                     // no attr. template 

	if (hFile == INVALID_HANDLE_VALUE) { 
		PrintErrorMessage(__FILE__, "CreateFile", __LINE__);
		ExitProcess(1);
	}

	/* NULL writing */
	{
		DWORD nBytesWritten;
		if (!WriteFile(hFile, NULL, 0, &nBytesWritten, NULL)) {
			PrintErrorMessage(__FILE__, "WriteFile", __LINE__);
			ExitProcess(1);
		}
	}

	CloseHandle(hFile);

	ExitProcess(0);
}